import javax.persistence.*;
import java.util.*;

@Entity public class Foo implements java.io.Serializable {

	@Id String id;
	
	// As a work around for issue #1327, don't declare using generic syntax.
	@Basic @Lob
	HashSet strings = new HashSet<String>(); 

	// As a work around for issue #1327, don't declare using generic syntax.
	@Basic @Lob
	HashMap map = new HashMap<String, Object>();

	public String getId() { 
		return id;
	}

	public void setId(String id) {
		this.id = id;
	}

	public Set<String> getStrings() {
		 return strings;
	}

	public void addString(String string) {
		this.strings.add(string);
	}

	public Map<String, Object> getMap() {
		return map;
	}

	public void addMapEntry(String s, Object o) {
		map.put(s, o);
	}

	@Override public String toString() {
		StringBuilder sb = new StringBuilder();
		sb.append("Foo: id=" + id + ", strings={");
		for(Iterator i = strings.iterator(); i.hasNext();) {
			sb.append(i.next());
			if(i.hasNext()) sb.append(", ");
		}
		sb.append("}");
		sb.append(", map={");
		for (Iterator<Map.Entry<String, Object>> i = map.entrySet().iterator(); i.hasNext();) {
			Map.Entry entry = i.next();
			sb.append("(" + entry.getKey() + ", " + entry.getValue()+ ")");
			if(i.hasNext()) sb.append(", ");
		}
		sb.append("}");
		return sb.toString();
	}

}
